#ifndef _AVATAR_H_
#define _AVATAR_H_

// trieda premennych a funkcii pre pracu s Avatarom
class CAvatar {
public:
 CAvatar();  // konstruktor
 ~CAvatar(); // destruktor

 vec3 actpos; // aktualna poloha Avatara

 // indikatory pre vykonavanie definovanych posunov Avatara
 GLfloat goForward,goBack,goUp,goDown,goRight,goLeft;

 // inicializacia Avatara
 void init(void);
 // reset parametrov Avatara
 void reset(void);

 // nastavenie prirastkov pre zmenu polohy Avatara
 void setmovxyz(void);
 // nastavenie prirastkov pre zmenu natocenia Avatara
 void setrotab(GLfloat A,GLfloat B);

 // aktualizacia parametrov Avatara
 void update(void);

 // projekcna matica
 GLfloat *get_pr_mat(void) { return(pr_mat.get()); }
 // transformacna matica
 GLfloat *get_mv_mat(void) { return(mv_mat.get()); }
private:
 GLfloat fov;               // zorny uhol pohladu
 GLfloat viewnear,viewfar;  // minimalny a maximalny dohlad

 mat4x4 pr_mat; // projection - projekcna perspektivna matica
 mat4x4 mv_mat; // modelview - transformacna matica

 vec3 dmove,drotate; // zmena polohy a natocenia
 vec3 p,q;           // pomocne vektory
};

#endif
