#ifndef _SHADER_H_
#define _SHADER_H_

// praca so shadermi *******************************************************

// pocet GLSL program objektov
#define GLSL_OBJ_NUM 10

// trieda premennych a funkcii pre pracu so shadermi
class CShader {
public:
 CShader();  // konstruktor
 ~CShader(); // destruktor

 // inicializacia pouzitia shaderov
 int init(void);

 // nacitanie kodu GLSL vertex & fragment shadera
 int load(const char *VP,const char *FP);
 void on(void);  // zapnutie GLSL shadera
 void off(void); // vypnutie GLSL shadera

 // nastavenie atributov
 void bindattriblocation(GLuint I,const char *NAME);
 // nastavenie uniform premennych
 void uniformI(const char *NAME,const int I);
 void uniformmatrixFV(const char *NAME,const GLfloat *M);
private:
#ifdef OGL20
 GLuint vertex,fragment,program;
#else
 GLhandleARB vertex,fragment,program;
#endif

 char log[10000];
 GLint log_length;

 GLint loc;

 // nacitanie obsahu textoveho suboru
 char *TextFileRead(const char *FNAME);
};

/*
 odovzdavanie udajov:
 uniform - per primitive (outside glBegin - glEnd)
           hodnoty platia pre cely objekt, nie pre kazdy vrchol osobitne
 attrib - per vertex (inside glBegin - glEnd)
          pre kazdy vrchol osobitne, citat (nie menit) mozno iba vo vertex shaderi
 varying - interpolovane udaje prenasane z vertex do fragment shadera
 textury - udaje o farbach texelov mozu predstavovat odovzdavane udaje

 vertex shader - po vypocte per vertex atributov su tieto interpolovane a
                 odovzdane fragment shaderu
 fragment shader - vystupom operacii s interpolovanymi udajmi je farba fragmentu
*/

#endif
